from support.slip_beginnings import slip_beginnings
from support.slip_endings import slip_endings


def find_quakes(threshold_velocity, maximum_velocities):
    slipping_times = maximum_velocities > threshold_velocity

    quake_starts = slip_beginnings(slipping_times)
    quake_ends = slip_endings(slipping_times)

    # remove incomplete quakes
    min_len = min(len(quake_starts), len(quake_ends))
    quake_ends = quake_ends[0:min_len]
    quake_starts = quake_starts[0:min_len]

    return [quake_starts, quake_ends]
